package fr.unicaen.openmap;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

import com.bbn.openmap.Layer;
import com.bbn.openmap.LayerHandler;

import fr.unicaen.openmap.layer.utils.AtlasLayerLoader;
import fr.unicaen.openmap.layer.utils.LayerLoader;
import fr.unicaen.openmap.util.TooManyLegendException;
import javax.swing.JOptionPane;

public class AtlasLoader {

	public final static String ATLAS_PATH = "atlas";
	public final static String PROPERTIES_EXTENSION = ".properties"; 

	
	public static Layer[] loadLayersFromPath(String path, AtlasLayerHandler lh) throws TooManyLegendException{
		ArrayList<Layer> omlayers = new ArrayList<Layer>();
		File file = new File(path);
		if(file.exists() && path.endsWith(".properties"))
		try{
			LayerLoader ll = new AtlasLayerLoader(file.toURI().toURL(), lh);
			String[] layers = ll.findAvailableLayers();
                        if(layers == null)
                            return null;

			for(int k = 0; k < layers.length; k++){
				omlayers.add(ll.initLayer(layers[k]));
			}
		}
		catch(IOException exc){ return null;}
		
		return omlayers.toArray(new Layer[omlayers.size()]);
	}
	
	
	
}
