/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.gui;

import com.bbn.openmap.Layer;
import com.bbn.openmap.LayerHandler;
import fr.unicaen.openmap.AtlasLayerHandler;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import fr.unicaen.openmap.util.Util;
import java.awt.Color;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.Icon;
import javax.swing.JCheckBox;
import javax.swing.JToggleButton;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

/**
 *
 * @author jchauvea
 */
public class AtlasLayerTreeNodeComponent extends LayerTreeNodeComponent {

    protected DefaultMutableTreeNode node;

    public AtlasLayerTreeNodeComponent(AtlasLayersTree tree, Layer layer, DefaultMutableTreeNode node) {
        super(tree, layer);
        this.node = node;
    }

    @Override
    protected JToggleButton getOnOffButton() {
        JCheckBox b = new JCheckBox(
                getIconForLayer(layer), (tree.getLayerHandler()).hasLayer(layer));
        b.setBorder(/*BorderFactory.createEmptyBorder(0,0,0,10)*/null);
        b.setBorderPainted(false);
        b.setFocusPainted(false);
        b.setBackground(Color.WHITE);
        b.setOpaque(false);
        b.setFocusable(true);

        b.addItemListener(new ItemListener() {

            public void itemStateChanged(ItemEvent e) {
                if (AtlasLayerTreeNodeComponent.this.getBackground() != Color.LIGHT_GRAY) {
                    AtlasLayerTreeNodeComponent.this.setBackground(Color.LIGHT_GRAY);
                }
                JCheckBox bsource = (JCheckBox) e.getSource();
                AtlasLayerHandler lh = (AtlasLayerHandler) tree.getLayerHandler();
                if (e.getStateChange() == ItemEvent.SELECTED) {
                    bsource.setIcon(Util.loadIcon("enabled.png"));
                    lh.loadLayer(layer);
                    tree.setSelectionPath(new TreePath(node.getPath()));
                    //((AtlasLayersTree) tree).selectCurrentLayer(node);
                } else {
                    bsource.setIcon(Util.loadIcon("disabled.png"));
                    lh.unloadLayer(layer);
                    //((AtlasLayersTree) tree).removeLayerChildNodes(layer);

//                    Layer newLayer = lh.unloadLayer(layer);
//                    node.setUserObject(newLayer);
//                    ((AtlasLayersTree) tree).fireLayerSynchronization(layer, newLayer);


                    /*if (newLayer instanceof ThematicDataDisplayLayer) {
                        ((ThematicDataDisplayLayer) newLayer).addThematicListener(tree);
                        System.out.println("add listener******");
                    }*/

 //                   ((AtlasLayersTree) tree).removeLayerChildNodes(newLayer);


                }
            }
        });
        return b;
    }

    private Icon getIconForLayer(Layer l) {
        AtlasLayerHandler alh = (AtlasLayerHandler) tree.getLayerHandler();
        //System.out.println("has layer ?????? " + l.getName() + " - " + alh.hasLayer(l));
        return alh.hasLayer(l) ? Util.loadIcon("enabled.png") : Util.loadIcon("disabled.png");
    }
}
