// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
/*
 * OMPopupPanel.java
 *
 * Created on 17 juillet 2006, 22:52
 *
 */

package fr.unicaen.openmap.layer.dataDisplayLayer.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

/**
 *
 * @author Arnaud Daret, arnaud.daret@info.unicaen.fr, CERTIC, Université de Caen, 2006.
 */
public class OMPopupPanel extends JPanel implements ActionListener {
    
    private JButton close = null;
    private JFrame frame = null;
    private String title = null;
    /**
     * Creates a new instance of OMPopupPanel
     */
    public OMPopupPanel(){
        super(new BorderLayout());
        close = new JButton("Fermer");
        close.addActionListener(this);
        JPanel p = new JPanel(new GridBagLayout());
        p.add(close, new GridBagConstraints(0, 0, 1, 1, 0, 0, GridBagConstraints.CENTER, GridBagConstraints.NONE,new Insets(0,0,0,0), 0, 0));
        this.add(p,BorderLayout.SOUTH);
    }
    
    public OMPopupPanel(String title) {
        this();
        this.title = title;
        // addTitle(new JLabel(title));
    }
    
    public void display(JPanel panel,int x, int y) {
        Component c = ((BorderLayout)getLayout()).getLayoutComponent(BorderLayout.CENTER);
        if (c!=null) this.remove(c);
        panel.setPreferredSize(new Dimension(500, 250));        
        this.add(panel,BorderLayout.CENTER);
        JFrame.setDefaultLookAndFeelDecorated(true);
        frame = new JFrame(title);
        frame.getContentPane().add(this,BorderLayout.CENTER);
        frame.setLocation(x,y);
        frame.pack();
        frame.setVisible(true);        
    }
    
    public void addTitle(JLabel label) {
        Component c = ((BorderLayout)getLayout()).getLayoutComponent(BorderLayout.NORTH);
        if (c!=null) this.remove(c);
        this.add(label,BorderLayout.NORTH);
    }
    
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == close) frame.setVisible(false);
    }
    
    public void updateGraphics() {
        try {
            if (getGraphics()!=null) paint(getGraphics());
        } catch(Exception e){
            // e.printStackTrace();
        }
    }
}
