// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.legendLayer.gui;

import com.bbn.openmap.util.Debug;
import fr.unicaen.openmap.layer.legendLayer.LegendLayer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.MouseControlPointsListener;
import java.awt.event.MouseEvent;

/**
 * MouseControlPointsListener that records the ``dragging state'' of the legend layer
 * @author jchauvea
 */
public class LegendLayerMouseListener extends MouseControlPointsListener {

    protected LegendLayer legendLayer;

    public LegendLayerMouseListener(LegendLayer ll) {
        this.legendLayer = ll;
    }

    /**
     * Invoked when a mouse button is pressed on a component and then dragged.
     */
    /*@Override
    public boolean mouseDragged(MouseEvent e) {
        return super.mouseDragged(e);
    }*/

    @Override
    public boolean mousePressed(MouseEvent e){
        legendLayer.setDragging(true);
        return super.mousePressed(e);
    }

    @Override
    public boolean mouseReleased(MouseEvent e) {
        legendLayer.setDragging(false);
        return super.mouseReleased(e);
    }
}
