/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

import fr.unicaen.openmap.gui.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ThematicConfPanel;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ThematicConfigurationPanel;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ThematicPalette;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import java.awt.Component;
import java.awt.Dimension;
import java.util.ArrayList;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import org.jdesktop.swingx.JXCollapsiblePane;

/**
 *Wrapper panel for thematic GUI
 * Able to change its orientation(Horizontal/Vertical) according to its parents width
 * @author jchauvea
 */
public class ThematicGUI extends Box {

    protected ArrayList<ThematicConfPanel> configPanels = new ArrayList<ThematicConfPanel>();
    private int axis;
    private Thematic thematic;

    /**
     * Constructor
     * @param axis
     * @param tv
     */
    public ThematicGUI(int axis, Thematic tv) {
        super(axis);
        this.axis = axis;
        this.thematic = tv;
    }

   /**
    * Copy content in a new ThematicGUI
    * @param axis
    * @return
    */
    public ThematicGUI copyWithNewOrientation(int axis) {
        ThematicGUI tg = new ThematicGUI(axis, thematic);      
        for (ThematicConfPanel tcf : configPanels) {
            JComponent content = tcf.getContent();
            ThematicConfPanel confPanel = ThematicConfPanel.createThematicConfPanel(tcf.getName());
            confPanel.setContent(content);
            tg.add(confPanel);
            tg.addThematicConfigurationPanel(confPanel);
        }
        tg.updateUI();
        return tg;
    }

    public void addThematicConfigurationPanel(ThematicConfPanel panel) {
        configPanels.add(panel);
    }

    public Thematic getThematic() {
        return thematic;
    }

    public ArrayList<ThematicConfPanel> getConfigPanels(){
        return configPanels;
    }

}
