/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScale;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.Colorizer;
import fr.unicaen.openmap.util.classification.ClassificationListener;
import fr.unicaen.openmap.util.classification.CustomizedClassification;
import fr.unicaen.openmap.util.classification.Discrete;
import fr.unicaen.openmap.util.gui.ComponentSizer;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author jchauvea
 */
public class ThresholdColorScalePanel extends ColorScalePanel implements ClassificationListener {

    protected Colorizer colorizer = null;
    protected JSpinner[] spinners;
    private CustomizedClassification customClassif;

    public ThresholdColorScalePanel(ColorScale cs, Colorizer colorizer) {
        super(cs);
        this.colorizer = colorizer;
        customClassif = new CustomizedClassification(null, colorScale.getColorNumber());
        colorizer.addClassificationListener(this);
        createColorScalePanel();
        createOptionPanel();
        setLayout(new BorderLayout());
        JPanel wrapOption = new JPanel(new BorderLayout());
        wrapOption.add(panOption, BorderLayout.NORTH);
        add(wrapOption, BorderLayout.WEST);
        add(panColorScale, BorderLayout.EAST);

    }

    @Override
    public void createOptionPanel() {
        super.createOptionPanel();
        remove(panOption);
        colorNumber.addChangeListener(new ChangeListener() {

            public void stateChanged(ChangeEvent arg0) {
                int n = ((Integer) colorNumber.getValue()).intValue();
                colorScale.setColorNumber(n);
                if (colorizer.getClassification() != null) {
                    colorizer.getClassification().setNumberOfClasses(n);
                }
                refreshPanel();
                return;
            }
        });
        updateUI();
    }

    @Override
    public void createColorScalePanel() {
        if (panColorScale == null) {
            panColorScale = new JPanel();
        }

        panColorScale.removeAll();
        //panColorScale.setBorder(BorderFactory.createEmptyBorder(0,-100,0,0));
        Box buttonsBox = Box.createVerticalBox();
        Box spinnersOrLabelsBox = buildSpinnersOrLabelsBox();
        Dimension buttonsDimension = new Dimension(20, 20);
        //colorButtons = new ColorScaleButton[colorScale.getColorNumber()];
        colorButtons.clear();
        ////spinners = new JSpinner[colorScale.getColorNumber() - 1];
        ToolTipColorScaleButton b = new ToolTipColorScaleButton(this, 0);
        colorButtons.add(b);
        b.setPreferredSize(buttonsDimension);
        b.setMaximumSize(buttonsDimension);
        b.setBackground(colorScale.getColor(0));
        b.setText(getColorButtonText(0));
        buttonsBox.add(b);
        buttonsBox.add(Box.createRigidArea(new Dimension(20, 2)));
        ////spinnersOrLabelsBox.add(Box.createRigidArea(new Dimension(20, 10)));
        ColorScaleButton lower = b;
        for (int i = 1; i < colorScale.getColorNumber(); i++) {
            b = new ToolTipColorScaleButton(this, i);
            b.setPreferredSize(buttonsDimension);
            b.setMaximumSize(buttonsDimension);
            b.setBackground(colorScale.getColor(i));
            buttonsBox.add(b);
            colorButtons.add(b);
            b.setText(getColorButtonText(i));
            //System.out.println("#####ColorizerColorScalePanel spinner value[" + i + "] =" + getSpinnerValue(i));
            //CSJSpinner sp = new CSJSpinner(lower, colorButtons[i], getSpinnerValue(i)); // , getSpinnerValue(i-1), getSpinnerValue(i+1));
            //spinners[i - 1].setPreferredSize(buttonsDimension);
            //spinners[i - 1].setMaximumSize(buttonsDimension);           
            buttonsBox.add(Box.createRigidArea(new Dimension(80, 2)));
            if (colorizer.getClassification() != null && colorizer.getClassification() instanceof Discrete) {
                Discrete dc = (Discrete)colorizer.getClassification();
                JLabel lab = new JLabel(dc.getClassText(i,""));
                ComponentSizer.fixComponentSize(lab, new Dimension(70, 20));
                spinnersOrLabelsBox.add(lab);
            } else {
                spinners[i - 1] = new CSJSpinner(lower, b, getSpinnerValue(i));
                spinnersOrLabelsBox.add(spinners[i - 1]);
            }
            spinnersOrLabelsBox.add(Box.createRigidArea(new Dimension(80, 2)));

            lower = b;

        }
        buttonsBox.setBorder(BorderFactory.createEmptyBorder(0, -30, 0, -20));
        panColorScale.add(buttonsBox);
        panColorScale.add(spinnersOrLabelsBox);
    }

    @Override
    public void updateColorScaleAt(int position, Color color) {
        super.updateColorScaleAt(position, color);
        colorizer.setColorScale(colorScale);
    }

    private Box buildSpinnersOrLabelsBox() {
        Box box = Box.createVerticalBox();
        if (colorizer.getClassification() != null && colorizer.getClassification() instanceof Discrete) {
            Discrete dc = (Discrete)colorizer.getClassification();
            JLabel lab = new JLabel(dc.getClassText(0,""));
            ComponentSizer.fixComponentSize(lab, new Dimension(70, 20));
            box.add(lab);
        } else {
            spinners = new JSpinner[colorScale.getColorNumber() - 1];
            box.add(Box.createRigidArea(new Dimension(20, 10)));
        }

        return box;
    }

    protected String getColorButtonText(int i) {
        return i < colorButtons.size() && colorizer != null ? colorizer.getColorText(i) : "";
    }

    protected double getSpinnerValue(int i) {
        try {
            if (colorizer != null && colorizer.getClassification() != null) {
                return colorizer.getClassification().getNthBreak(i);
            }
            return 0;
        } catch (Exception e) {
            System.err.println(e.getMessage());
            return 0;
        }
    }

    public void classificationChanged(Object source) {
        //setVisible(false);
        //invalidate();
        //removeAll();
        // reset ColorScale color number
        if (colorizer.getClassification() != null) {
            colorizer.getColorScale().setColorNumber(colorizer.getClassification().getNumberOfClasses());
        }

        SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                refreshPanel();
                updateUI();
            }
        });

        //validate();
        //setVisible(true);
    }

    private class CSJSpinner extends JSpinner implements ChangeListener {

        private JButton upper;
        private JButton lower;

        public CSJSpinner(ColorScaleButton lower, ColorScaleButton upper, double value) { // , double min, double max) {
            super(new SpinnerNumberModel((value < 0) ? 0 : value, 0, Double.MAX_VALUE, 1));
            // super(new SpinnerNumberModel(colorScale.getColorNumber(), 1, 10, 1));
            /*setPreferredSize(new Dimension(70, 20));
            setMinimumSize(new Dimension(70, 20));
            setMaximumSize(new Dimension(70, 20));*/
            ComponentSizer.fixComponentSize(this, new Dimension(70, 20));
            setFont(new Font("Arial", Font.PLAIN, 8));
            this.upper = upper;
            this.lower = lower;
            addChangeListener(this);
        }

        //Enables CUSTOM CLASSIFICATION MODE -- change breaks in live
        public void stateChanged(ChangeEvent e) {
            double value = ((Double) this.getValue()).doubleValue();

            if (colorizer.getClassification() != null && (!(colorizer.getClassification() instanceof CustomizedClassification) || colorizer.getClassification() != customClassif)) {

                customClassif.reInit(colorizer.getClassification());
                customClassif.setNthBreak(((ColorScaleButton) upper).getPosition(), value);
                colorizer.setClassification(customClassif);
                // customClassif.setNthBreak(((ColorScaleButton) upper).getPosition(), value);
                return;
            }
            if (colorizer.getClassification() == null) {
                colorizer.setClassification(customClassif);
            }
            customClassif.setNthBreak(((ColorScaleButton) upper).getPosition(), value);
            int iLow = ((ColorScaleButton) upper).getPosition();
            lower.setText(getColorButtonText(((ColorScaleButton) lower).getPosition()));
            upper.setText(getColorButtonText(((ColorScaleButton) upper).getPosition()));
            // System.out.println("####ColorizerColorScalePanel: " + colorizer.getClassification());
            return;
        }
    }

    @Override
    public void setEnabled(boolean b) {
        super.setEnabled(b);
        if(spinners != null)
        for (JSpinner sp : spinners) {
            sp.setEnabled(b);
        }
    }
}
