/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import fr.unicaen.openmap.omGraphics.DrawingAttributes;
import java.awt.Paint;

/**
 *Drawing Attributes for a thematic. It refreshs its thematic when line or fill
 * paint color has changed
 * @author dje
 */
public class ThematicDrawingAttributes extends DrawingAttributes {

    private Thematic thematic;

    public ThematicDrawingAttributes(Thematic thematic, boolean bColorMenu, boolean bCapMenu, boolean bJointMenu, boolean bLinePaint, boolean bFillPaint) {
        super(bColorMenu, bCapMenu, bJointMenu, bLinePaint, bFillPaint);
        this.thematic = thematic;
    }

    @Override
    public void setFillPaint(Paint paint){
        super.setFillPaint(paint);
        thematic.setBadCache(true);
        thematic.getLayer().refreshGraphics();
    }

    @Override
    public void setLinePaint(Paint paint){
        super.setLinePaint(paint);
        thematic.setBadCache(true);
        thematic.getLayer().refreshGraphics();
    }

    @Override
    public void setFilled(boolean b){
        super.setFilled(b);
        thematic.setBadCache(true);
        thematic.getLayer().refreshGraphics();
    }
}
