// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util;

import java.awt.Color;
import javax.swing.JButton;

/**
 * This class provides a JButton with a colored icon.
 */
public class ColorButton extends JButton {
    
    private Color color;
    
    public ColorButton(Color color) {
        super();
        if (color != null) {
            this.color = color;
            setBackground(color);
            //setText(Integer.toHexString(color.getRGB()));
            //setIcon(new ColorIcon(color));
        } else {
            setBackground(new Color(0, true));
            //setIcon(new ColorIcon(new Color(0, true)));
            //setText("Choisir une couleur ...");
        }
    }
    
    public void setColor(Color color) {
        if (color!=null) {
            //setText(Integer.toHexString(color.getRGB()));
            setBackground(color);
        }
    }
    
    public Color getColor() {
        return getBackground();
    }
}
