// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util;

/* YL */

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JButton;

/**
 * An other way to supply by example
 * JButton b = new JButton("OK");
 * b.addActionListener(new ActionListener() {
 *      public void actionPerformed(ActionEvent e) {
 *
 *      }
 *   });
 *
 * Using this class like this :
 * JActionButton b = new JActionButton("OK"){
 *	public void actionPerformed(ActionEvent e)
 *	{
 *	    System.out.println("Exécution !");
 *	    //...
 *	}
 *   };
 * One line less...
 */
public class JActionButton extends JButton implements ActionListener
{
    /**
     * Constructs a new JActionButton and with an ActionListener
     * @param name String representation which appears on button
     */
    public JActionButton (String name)
    {
	super(name);

	addActionListener(this);
    }

    /**
     * Constructs a new JActionButton (with "Go") and add an ActionListener
     */
    public JActionButton()
    {
	this("Go");
    }

    /**
     * Necessary to implements this method in your JActionButton th have effects.
     */
    public void actionPerformed(ActionEvent e)
    {
	System.err.println("JActionButton, wait...");
    }
}
