// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.propertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.PropertyEditorSupport;
import com.bbn.openmap.util.propertyEditor.TrueFalsePropertyEditor;

/**
 * A PropertyEditor that a checked box. The widget returns
 * true or false as a string when queried.
 */
public class CheckBoxPropertyEditor extends PropertyEditorSupport {
    protected JCheckBox cb;

    public boolean supportsCustomEditor() {
        return true;
    }

    public Component getCustomEditor() {
	Box box = Box.createHorizontalBox();
	cb = new JCheckBox("");
	box.add(cb);
	return box;
    }

    /** Sets String in JTextField. */
    public void setValue(Object string) {
        if (!(string instanceof String)) {
            return;
        }

        cb.setSelected(((String) string).equalsIgnoreCase("true"));
    }

    /** Returns String from ButtonGroup. */
    public String getAsText() {
        return cb.isSelected() ? "true" : "false";
    }
}
